<!--检测项目编辑列表（添加、导入检测项目）-->
<template>
  <div>
    <Modal
      v-model="showModal"
      :mask-closable="false"
      :width="690"
      title="库房信息"
    >
      <Row>
        <Col span="24">
        <Form v-model="formObj" :label-width="90" inline onsubmit="return false">
          <Form-item class="search-item" label="库房号:" style="margin-left: -25px">
            <Input v-model="formObj.warehouse" @on-enter="_formSearch" placeholder="请输入库房号" clearable />
          </Form-item>
          <!--          <Form-item class="search-item" label="检测依据:">-->
          <!--            <Input v-model="formObj.code" placeholder="请输入检测依据名称" clearable @on-enter="_formSearch" />-->
          <!--          </Form-item>-->
          <Form-item class="search-btn">
            <Button @click="_formSearch" type="primary">
              搜索
            </Button>
          </Form-item>
        </Form>
        </Col>
        <!--正常界面-->
        <Col span="24">
        <btn-list :msg="btn" :open="searchOpen" @on-result-change="_btnClick" />
        </Col>
        <!-- 表格 -->
        <Col span="24">
          <PTVXETable ref="pageTable" :loading="true"
                      :get-page="getPage" :icon-msg="iconMsg" @on-result-change="_tableResultChange" :hide-checkbox="true" :is-radio="true" select-data>
            <vxe-table-column
              v-for="item in pageColumns"
              :key="item.key"
              :field="item.key"
              :title="item.title"
              :min-width="item.width?item.width:200"
              :fixed="item.fixed?item.fixed:undefined" sortable>
            <template slot-scope="scope">
              <span v-if="item.key==='judged'">
                {{ scope.row[item.key]===1?'是':'否' }}
              </span>
              <div v-else-if="item.key==='compareSymbol'" @click.stop="_handleRow(scope)">
                <el-input
                  v-model="scope.row.compareSymbol"
                  placeholder="请输入比较符"
                />
              </div>
              <div v-else-if="item.key==='limitValue'" @click.stop="_handleRow(scope)">
                <el-input
                  v-model="scope.row.limitValue"
                  placeholder="请输入限值"
                />
              </div>
              <div v-else-if="item.key==='unit'" @click.stop="_handleRow(scope)">
                <el-input
                  v-model="scope.row.unit"
                  placeholder="请输入单位"
                />
              </div>
              <div v-else-if="item.key==='code'" @click.stop="_handleRow(scope)">
                <el-input
                  v-model="scope.row.code"
                  style="width: 130px;"
                  blur
                  placeholder="请选择检测依据"
                />
                <i @click.stop="_selectjudgeBasis(scope.$index)" style="cursor: pointer;font-size: 14px;" class="icons iconfont pt-search icon-search"></i>
              </div>
              <span v-else>
                {{ scope.row[item.key] }}
              </span>
            </template>
            </vxe-table-column>
          </PTVXETable>
        </Col>
      </Row>
      <div slot="footer">
        <modal-footer ref="footerModal" :footer="footerList" @on-result-change="_footerResult" />
      </div>
    </Modal>
  </div>
</template>
<script>
import { soilSample } from '../../api'

export default {
  components: {},
  data() {
    return {
      formObj: {
        catalogueId: '',
        name: '',
        code: '',
        standardCode: '',
        standardName: ''
      },
      showModal: false,
      searchOpen: false,
      btn: [],
      index: '',
      iconMsg: [],
      footerList: [
        { id: '', name: '取消', type: '' },
        { id: '', name: '保存', type: 'primary' }
      ],
      pageColumns: [
        { title: '库房名', key: 'warehouse', width: 140 },
        { title: '货架号', key: 'name', width: 140 }
        // { title: '设备', key: 'device', width: 180 },
        // { title: '检测依据', key: 'code', width: 180 },
        // { title: '检测科室', key: 'groupName', width: 110 },
        // { title: '比较符', key: 'compareSymbol', width: 120 },
        // { title: '限值', key: 'limitValue' },
        // { title: '单位', key: 'unit' },
        // { title: '是否系统判定', key: 'judged', width: 120, judged: true },
        // { title: '备注', key: 'remark' }
      ],
      catalogueId: '',
      getPage: {},
      selectData: []
    }
  },
  methods: {
    _open(catalogueId, label) {
      this.formObj = this.$resetFields(this.formObj)
      this.showModal = true
      this.catalogueId = catalogueId
      this.formObj.catalogueId = catalogueId
      this.getPage.records = []
      this.$refs.pageTable._hideLoading()
      this.selectData = []
      this._page()
      // if (catalogueId) {
      //   this._page()
      // }
    },
    _handleRow(scope) {
      console.log(scope)
    },
    _selectjudgeBasis(index) {
      console.log(index)
      this.index = index
      this.$refs.EditModal._open()
    },
    _backData(data) {
      console.log(typeof this.index)
      this.getPage.records[this.index].code = data.code
      this.$set(
        this.getPage.records,
        this.index,
        this.getPage.records[this.index]
      )
      console.log(this.getPage.records)
    },
    _formSearch() {
      this.$refs.pageTable._pageChange(1)
    },
    _footerResult(name) {
      switch (name) {
        case '取消':
          this._cancel()
          break
        case '保存':
          this._ok()
          break
      }
    },
    _page: async function() {
      Object.assign(this.formObj, this.$refs.pageTable._searchParams())
      const result = await soilSample.aloneWarehouseLocation(
        this.$serializeForm(this.formObj)
      )
      if (result) {
        this.$refs.pageTable._hideLoading()
        this.getPage = result
      }
    },
    _btnClick(msg) {
      switch (msg) {
        case '导入检测项目':
          this.$refs.relItemModal._open(this.catalogueId)
          break
      }
    },
    // 操作列操作
    _iconClick(res, data) {
      switch (res) {
        case '删除':
          this._deleteById(data.relPackageId)
          break
      }
    },
    // 删除
    _deleteById(id) {
      this.$Modal.confirm({
        title: '提示',
        content: '确定删除该数据？',
        onOk: () => {
          this._deleteOk(id)
        }
      })
    },
    // _deleteOk: async function(id) {
    //   // const result = await drugCatalogueItem.deleteById(id)
    //   if (result) {
    //     this.$Message.success('删除成功')
    //     this._page()
    //   }
    // },
    // table结果  返回整行
    _tableResultChange(msg, data) {
      console.log(msg, data)
      switch (msg) {
        case 'page':
          this._page()
          break
        case 'selectData':
          this.selectData = data
          break
        case 'singleSelect':
          this.selectData = []
          this.selectData = data
          break
        case 'iconClick':
          this._iconClick(data.name, data.rowData)
          break
        case 'changeSize':
          this._page()
          break
      }
    },
    _ok() {
      const data = this.selectData
      if (data.length === 0) {
        this._hideLoading()
        this.$Message.warning('请选择至少一条数据！')
      }
      // const ids = []
      // data.forEach(item => {
      //   ids.push(item.id)
      // })
      this._saveCatalogueItem(data)
    },
    _saveCatalogueItem(data) {
      this.showModal = false
      this._hideLoading()
      this.$emit('on-result-change', data)
      console.log('data------', data)
      this._hideLoading()
    },
    _cancel() {
      this.selectData = []
      this.showModal = false
    },
    _hideLoading() {
      this.$refs.footerModal._hideLoading()
    }
  }
}
</script>
